"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Checkbox = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _enums = require("../enums");

var _templates = require("../templates");

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject, _templateObject2;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var CheckboxItem = _styledComponents["default"].input(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  ", "\n  ", "\n  ", "\n\n  &:checked::before {\n    content: '';\n    width: 90%;\n    height: 90%;\n    ", "\n    ", "\n    color: ", ";\n  }\n\n  &:checked::after {\n    content: '';\n    position: ", ";\n    height: 40%;\n    width: 14%;\n    ", "\n    border-style: ", ";\n    border-width: 0 2px 2px 0;\n    transform: rotate(45deg);\n    margin-bottom: 2px;\n  }\n"])), _templates.baseTemplate, function (props) {
  var _props$styled, _props$styled2;

  return (props === null || props === void 0 ? void 0 : (_props$styled = props.styled) === null || _props$styled === void 0 ? void 0 : _props$styled.appearance) !== undefined && "appearance: ".concat(props === null || props === void 0 ? void 0 : (_props$styled2 = props.styled) === null || _props$styled2 === void 0 ? void 0 : _props$styled2.appearance, ";");
}, function (props) {
  var _props$styled3, _props$styled4;

  return (props === null || props === void 0 ? void 0 : (_props$styled3 = props.styled) === null || _props$styled3 === void 0 ? void 0 : _props$styled3.tickBackgroundColor) !== undefined && "border-color: ".concat(props === null || props === void 0 ? void 0 : (_props$styled4 = props.styled) === null || _props$styled4 === void 0 ? void 0 : _props$styled4.tickBackgroundColor, ";");
}, function (props) {
  var _props$styled5, _props$styled6;

  return (props === null || props === void 0 ? void 0 : (_props$styled5 = props.styled) === null || _props$styled5 === void 0 ? void 0 : _props$styled5.borderRadius) !== undefined && "border-radius: ".concat(props === null || props === void 0 ? void 0 : (_props$styled6 = props.styled) === null || _props$styled6 === void 0 ? void 0 : _props$styled6.borderRadius, ";");
}, function (props) {
  var _props$styled7, _props$styled8;

  return (props === null || props === void 0 ? void 0 : (_props$styled7 = props.styled) === null || _props$styled7 === void 0 ? void 0 : _props$styled7.tickBackgroundColor) !== undefined && "background-color: ".concat(props === null || props === void 0 ? void 0 : (_props$styled8 = props.styled) === null || _props$styled8 === void 0 ? void 0 : _props$styled8.tickBackgroundColor, ";");
}, _enums.Color.White, _enums.Position.Absolute, function (props) {
  var _props$styled9, _props$styled10;

  return (props === null || props === void 0 ? void 0 : (_props$styled9 = props.styled) === null || _props$styled9 === void 0 ? void 0 : _props$styled9.tickColor) !== undefined && "border-color: ".concat(props === null || props === void 0 ? void 0 : (_props$styled10 = props.styled) === null || _props$styled10 === void 0 ? void 0 : _props$styled10.tickColor, ";");
}, _enums.BorderStyle.Solid);

var CheckboxLabel = _styledComponents["default"].label(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  ", ";\n  display: ", ";\n  align-items: ", ";\n"])), _templates.textTemplate, _enums.Display.Flex, _enums.AlignItems.Center);

var Checkbox = function Checkbox(props) {
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(CheckboxLabel, {
    styled: props,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(CheckboxItem, {
      type: 'checkbox',
      name: props.name,
      value: props.value,
      checked: props.checked,
      disabled: props.disabled,
      onChange: props.onChange,
      styled: props
    }), props.labelText]
  });
};

exports.Checkbox = Checkbox;
Checkbox.displayName = 'Checkbox';
Checkbox.propTypes = _objectSpread(_objectSpread(_objectSpread({}, _templates.baseStyledPropTypes), _templates.textStyledPropTypes), {}, {
  name: _propTypes["default"].string.isRequired,
  labelText: _propTypes["default"].string.isRequired,
  value: _propTypes["default"].string.isRequired,
  checked: _propTypes["default"].bool.isRequired,
  disabled: _propTypes["default"].bool,
  appearance: _propTypes["default"].string,
  onChange: _propTypes["default"].func.isRequired,
  tickColor: _propTypes["default"].string,
  tickBackgroundColor: _propTypes["default"].string
});
Checkbox.defaultProps = _objectSpread(_objectSpread(_objectSpread({}, _templates.baseStyledDefaultProps), _templates.textStyledDefaultProps), {}, {
  name: '',
  labelText: '',
  value: '',
  checked: false,
  disabled: false,
  onChange: function onChange() {},
  appearance: 'none',
  margin: '10px 10px 10px 0',
  width: '22px',
  height: '22px',
  borderWidth: '2px',
  borderStyle: _enums.BorderStyle.Solid,
  borderRadius: '25%',
  tickColor: _enums.Color.White,
  tickBackgroundColor: _enums.Color.BrightTurquoise,
  alignItems: _enums.AlignItems.Center,
  justifyContent: _enums.JustifyContent.Center,
  fontFamily: _enums.FontFamily.Default,
  fontSize: _enums.FontSize.Small,
  color: _enums.Color.MedGrey
});