"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Input = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _templates = require("../templates");

var _enums = require("../enums");

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var MainContainer = _styledComponents["default"].div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  ", ";\n\n  display: ", ";\n  flex-direction: ", ";\n"])), _templates.baseTemplate, _enums.Display.Flex, _enums.FlexDirection.Column);

var InputContainer = _styledComponents["default"].div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  flex: 1;\n  display: ", ";\n  flex-direction: ", ";\n  align-items: ", ";\n  border-color: ", ";\n  margin: 5px 0;\n  border-style: ", ";\n  border-width: ", ";\n  border-radius: ", ";\n  background-color: ", ";\n"])), _enums.Display.Flex, _enums.FlexDirection.Row, _enums.AlignItems.Center, function (props) {
  return props.focused && props.focusBorderColor || props.borderColor;
}, _enums.BorderStyle.Solid, function (props) {
  return props.borderWidth;
}, function (props) {
  return props.borderRadius;
}, function (props) {
  return props.backgroundColor;
});

var InputBox = _styledComponents["default"].input(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  ", ";\n\n  outline: none;\n  border: none;\n  height: 100%;\n  width: 100%;\n  font-size: ", ";\n  padding: ", ";\n  background-color: ", ";\n  box-sizing: ", ";\n  flex: 1;\n"])), _templates.textTemplate, function (props) {
  return props.fontSize;
}, function (props) {
  return props.padding;
}, _enums.Color.Transparent, _enums.BoxSizing.BorderBox);

var Text = _styledComponents["default"].p(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  ", ";\n\n  flex: 0;\n  ", "\n"])), _templates.textTemplate, function (props) {
  var _props$styled, _props$styled2;

  return (props === null || props === void 0 ? void 0 : (_props$styled = props.styled) === null || _props$styled === void 0 ? void 0 : _props$styled.margin) !== undefined && "margin: ".concat(props === null || props === void 0 ? void 0 : (_props$styled2 = props.styled) === null || _props$styled2 === void 0 ? void 0 : _props$styled2.margin, ";");
});

var Icon = _styledComponents["default"].img(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n  height: ", ";\n  width: ", ";\n  margin: ", ";\n  position: ", ";\n  right: 0;\n  flex: 0;\n"])), function (props) {
  return props.height;
}, function (props) {
  return props.width;
}, function (props) {
  return props.margin;
}, _enums.Position.Absolute);

var Input = function Input(props) {
  var _React$useState = _react["default"].useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      focused = _React$useState2[0],
      setFocused = _React$useState2[1];

  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(MainContainer, {
    styled: props,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Text //Label
    , {
      styled: _objectSpread(_objectSpread({}, props), {}, {
        textAlign: props.labelTextAlign,
        fontSize: props.labelFontSize,
        fontWeight: props.labelFontWeight,
        color: props.labelColor,
        margin: props.labelTextMargin
      }),
      children: props.labelText
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(InputContainer, {
      borderRadius: props.inputBorderRadius,
      borderWidth: props.inputBorderWidth,
      focusBorderColor: props.focusBorderColor,
      borderColor: props.inputBorderColor,
      backgroundColor: props.inputBackgroundColor,
      focused: focused,
      children: [props.showPrefix && /*#__PURE__*/(0, _jsxRuntime.jsx)(Text //Prefix
      , {
        styled: _objectSpread(_objectSpread({}, props), {}, {
          margin: props.prefixMargin,
          fontSize: props.prefixFontSize,
          color: props.prefixColor
        }),
        children: props.prefix
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(InputBox, {
        styled: props,
        fontSize: props.inputBoxFontSize,
        padding: props.inputBoxPadding,
        type: props.type === _enums.InputTypes.Password && props.showPassword && _enums.InputTypes.Text || props.type,
        placeholder: props.placeholder,
        required: props.required,
        value: props.value,
        onChange: props.onChange,
        disabled: props.disabled,
        readOnly: props.readOnly,
        maxLength: props.maxLength,
        min: props.min,
        max: props.max,
        step: props.step,
        onFocus: function onFocus() {
          setFocused(true);
          typeof props.onFocus === 'function' && props.onFocus();
        },
        onBlur: function onBlur() {
          setFocused(false);
          typeof props.onBlur === 'function' && props.onBlur();
        }
      }), props.showIcon && /*#__PURE__*/(0, _jsxRuntime.jsx)(Icon, {
        onClick: !props.disabled && props.onIconClick,
        src: props.iconSrc,
        width: props.iconWidth,
        height: props.iconHeight,
        margin: props.iconMargin
      })]
    }), !!props.showRequiredText && !props.showValidationText && /*#__PURE__*/(0, _jsxRuntime.jsx)(Text //Required Indicator
    , {
      styled: _objectSpread(_objectSpread({}, props), {}, {
        color: props.requiredTextColor,
        margin: props.requiredTextMargin,
        fontSize: props.requiredTextFontSize
      }),
      children: props.requiredText
    }), !!props.showValidationText && /*#__PURE__*/(0, _jsxRuntime.jsx)(Text //Validation Indicator
    , {
      styled: _objectSpread(_objectSpread({}, props), {}, {
        color: props.validationTextColor,
        margin: props.validationTextMargin,
        fontSize: props.validationTextFontSize
      }),
      children: props.validationText
    })]
  });
};

exports.Input = Input;
Input.displayName = 'Input';
Input.defaultProps = _objectSpread(_objectSpread(_objectSpread({}, _templates.baseStyledDefaultProps), _templates.textStyledDefaultProps), {}, {
  labelText: '',
  labelColor: _enums.Color.Black,
  labelFontSize: _enums.FontSize.Big,
  labelFontWeight: _enums.FontWeight.Bold,
  labelTextAlign: _enums.TextAlign.Left,
  labelTextMargin: '0',
  placeholder: 'Enter text',
  validationText: '',
  showValidationText: false,
  validationTextColor: _enums.Color.Negative,
  validationTextFontSize: _enums.FontSize.Small,
  validationTextMargin: '0',
  requiredText: 'This field is required',
  showRequiredText: false,
  requiredTextColor: _enums.Color.MedGrey,
  requiredTextFontSize: _enums.FontSize.Small,
  requiredTextMargin: '0',
  focusBorderColor: _enums.Color.MedGrey,
  inputBorderColor: _enums.Color.MedGrey,
  iconSrc: '',
  showIcon: false,
  type: _enums.InputTypes.Text,
  required: false,
  showPassword: false,
  disabled: false,
  readOnly: false,
  maxLength: 255,
  min: 0,
  max: 100,
  step: 1,
  iconHeight: '45%',
  iconMargin: '0 10px 0 0',
  prefix: '',
  showPrefix: false,
  prefixColor: _enums.Color.BrightTurquoise,
  prefixMargin: '0 0 0 20px',
  prefixFontSize: _enums.FontSize.Normal,
  inputBoxPadding: '20px',
  inputBoxFontSize: _enums.FontSize.Small,
  inputBorderWidth: '1px',
  inputBorderRadius: '7px',
  inputBackgroundColor: _enums.Color.White
});
Input.propTypes = _objectSpread(_objectSpread(_objectSpread({}, _templates.baseStyledPropTypes), _templates.textStyledPropTypes), {}, {
  labelText: _propTypes["default"].string,
  labelColor: _propTypes["default"].string,
  labelFontSize: _propTypes["default"].string,
  labelFontWeight: _propTypes["default"].string,
  labelTextAlign: _propTypes["default"].string,
  labelTextMargin: _propTypes["default"].string,
  placeholder: _propTypes["default"].string,
  validationText: _propTypes["default"].string,
  validationTextColor: _propTypes["default"].string,
  validationTextFontSize: _propTypes["default"].string,
  validationTextMargin: _propTypes["default"].string,
  showValidationText: _propTypes["default"].bool,
  requiredText: _propTypes["default"].string,
  requiredTextColor: _propTypes["default"].string,
  requiredTextFontSize: _propTypes["default"].string,
  requiredTextMargin: _propTypes["default"].string,
  showRequiredText: _propTypes["default"].bool,
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  onChange: _propTypes["default"].func,
  type: _propTypes["default"].oneOf(Object.values(_enums.InputTypes)),
  focusBorderColor: _propTypes["default"].string,
  inputBorderColor: _propTypes["default"].string,
  required: _propTypes["default"].bool,
  showPassword: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  readOnly: _propTypes["default"].bool,
  maxLength: _propTypes["default"].number,
  min: _propTypes["default"].number,
  max: _propTypes["default"].number,
  step: _propTypes["default"].number,
  onIconClick: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  iconSrc: _propTypes["default"].string,
  showIcon: _propTypes["default"].bool,
  iconWidth: _propTypes["default"].string,
  iconHeight: _propTypes["default"].string,
  iconMargin: _propTypes["default"].string,
  prefix: _propTypes["default"].string,
  showPrefix: _propTypes["default"].bool,
  prefixColor: _propTypes["default"].string,
  prefixMargin: _propTypes["default"].string,
  prefixFontSize: _propTypes["default"].string,
  inputBoxPadding: _propTypes["default"].string,
  inputBoxFontSize: _propTypes["default"].string,
  inputBorderWidth: _propTypes["default"].string,
  inputBorderRadius: _propTypes["default"].string,
  inputBackgroundColor: _propTypes["default"].string
});