"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Toggle = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _enums = require("../enums");

var _templates = require("../templates");

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var ToggleContainer = _styledComponents["default"].label(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  ", ";\n\n  display: ", ";\n  flex-direction: ", ";\n  align-items: ", ";\n"])), _templates.baseTemplate, _enums.Display.Flex, _enums.FlexDirection.Row, _enums.AlignItems.Center);

var Switch = _styledComponents["default"].div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  width: ", ";\n  height: ", ";\n  border-radius: ", ";\n  background-color: ", ";\n  display: ", ";\n  flex-direction: ", ";\n  align-items: ", ";\n  transition: background-color ", ";\n  cursor: pointer;\n"])), function (props) {
  return props.width;
}, function (props) {
  return props.height;
}, function (props) {
  return props.borderRadius;
}, function (props) {
  return props.checked && _enums.Color.BrightTurquoise || _enums.Color.MedGrey;
}, _enums.Display.Flex, _enums.FlexDirection.Row, _enums.AlignItems.Center, _enums.TransitionDuration.Standard);

var Slider = _styledComponents["default"].div(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  margin: ", ";\n  width: ", ";\n  height: ", ";\n  background-color: ", ";\n  border-radius: ", ";\n  cursor: pointer;\n"])), function (props) {
  return props.margin;
}, function (props) {
  return props.width;
}, function (props) {
  return props.height;
}, function (props) {
  return props.backgroundColor;
}, function (props) {
  return props.borderRadius;
});

var Label = _styledComponents["default"].p(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  ", ";\n\n  flex: 1;\n  margin: ", ";\n"])), _templates.textTemplate, function (props) {
  return props.margin;
});

var HiddenCheckbox = _styledComponents["default"].input(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n  visibility: ", ";\n  position: ", ";\n"])), _enums.Visibility.Hidden, _enums.Position.Absolute);

var Spacer = _styledComponents["default"].div(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n  visibility: ", ";\n  flex-grow: ", ";\n  transition: flex-grow ", ";\n"])), _enums.Visibility.Hidden, function (props) {
  return props.checked && 1 || 0;
}, _enums.TransitionDuration.Standard);

var Toggle = function Toggle(props) {
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(ToggleContainer, {
    styled: props,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(HiddenCheckbox, {
      type: 'checkbox',
      checked: props.checked,
      onChange: props.onChange,
      disabled: props.readOnly
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(Switch, {
      checked: props.checked,
      width: props.switchWidth,
      height: props.switchHeight,
      borderRadius: props.switchBorderRadius,
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Spacer, {
        checked: props.checked
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(Slider, {
        checked: props.checked,
        margin: props.sliderMargin,
        width: props.sliderWidth,
        height: props.sliderHeight,
        backgroundColor: props.sliderColor,
        borderRadius: props.sliderBorderRadius
      })]
    }), !!props.labelText && /*#__PURE__*/(0, _jsxRuntime.jsx)(Label, {
      styled: props,
      margin: props.labelMargin,
      children: props.labelText
    })]
  });
};

exports.Toggle = Toggle;
Toggle.displayName = 'Toggle';
Toggle.defaultProps = _objectSpread(_objectSpread(_objectSpread({}, _templates.baseStyledDefaultProps), _templates.textStyledDefaultProps), {}, {
  width: '250px',
  fontSize: _enums.FontSize.Big,
  fontWeight: _enums.FontWeight.Bold,
  sliderMargin: '0 3px 0 3px',
  sliderWidth: '30px',
  sliderHeight: '30px',
  sliderColor: _enums.Color.White,
  sliderBorderRadius: _enums.BorderRadius.Ellipse,
  switchWidth: '60px',
  switchHeight: '36px',
  switchBorderRadius: '30px',
  labelMargin: "0 0 0 ".concat(_enums.Margin.Medium),
  readOnly: false
});
Toggle.propTypes = _objectSpread(_objectSpread(_objectSpread({}, _templates.baseStyledPropTypes), _templates.textStyledPropTypes), {}, {
  checked: _propTypes["default"].bool,
  onChange: _propTypes["default"].func,
  sliderMargin: _propTypes["default"].string,
  sliderWidth: _propTypes["default"].string,
  sliderHeight: _propTypes["default"].string,
  sliderColor: _propTypes["default"].oneOf(Object.values(_enums.Color)),
  sliderBorderRadius: _propTypes["default"].string,
  switchWidth: _propTypes["default"].string,
  switchHeight: _propTypes["default"].string,
  switchBorderRadius: _propTypes["default"].string,
  labelText: _propTypes["default"].string,
  labelMargin: _propTypes["default"].string,
  readOnly: _propTypes["default"].bool
});