"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Button = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _enums = require("../../enums");

var _templates = require("../../templates");

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var ButtonProto = _styledComponents["default"].button(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  ", ";\n  ", ";\n\n  &:hover:not(:disabled),\n  &:active:not(:disabled),\n  &:focus {\n    outline: 0;\n    ", "\n    ", "\n    ", "\n\t  cursor: pointer\n  }\n\n  &:disabled {\n    ", "\n    ", "\n  }\n"])), _templates.baseTemplate, _templates.textTemplate, function (props) {
  var _props$styled, _props$styled2;

  return (props === null || props === void 0 ? void 0 : (_props$styled = props.styled) === null || _props$styled === void 0 ? void 0 : _props$styled.hoverColor) !== undefined && "color: ".concat(props === null || props === void 0 ? void 0 : (_props$styled2 = props.styled) === null || _props$styled2 === void 0 ? void 0 : _props$styled2.hoverColor, ";");
}, function (props) {
  var _props$styled3, _props$styled4;

  return (props === null || props === void 0 ? void 0 : (_props$styled3 = props.styled) === null || _props$styled3 === void 0 ? void 0 : _props$styled3.hoverBackgroundColor) !== undefined && "background-color: ".concat(props === null || props === void 0 ? void 0 : (_props$styled4 = props.styled) === null || _props$styled4 === void 0 ? void 0 : _props$styled4.hoverBackgroundColor, ";");
}, function (props) {
  var _props$styled5, _props$styled6;

  return (props === null || props === void 0 ? void 0 : (_props$styled5 = props.styled) === null || _props$styled5 === void 0 ? void 0 : _props$styled5.hoverTextDecoration) !== undefined && "text-decoration: ".concat(props === null || props === void 0 ? void 0 : (_props$styled6 = props.styled) === null || _props$styled6 === void 0 ? void 0 : _props$styled6.hoverTextDecoration, ";");
}, function (props) {
  var _props$styled7, _props$styled8;

  return (props === null || props === void 0 ? void 0 : (_props$styled7 = props.styled) === null || _props$styled7 === void 0 ? void 0 : _props$styled7.disabledColor) !== undefined && "color: ".concat(props === null || props === void 0 ? void 0 : (_props$styled8 = props.styled) === null || _props$styled8 === void 0 ? void 0 : _props$styled8.disabledColor, ";");
}, function (props) {
  var _props$styled9, _props$styled10;

  return (props === null || props === void 0 ? void 0 : (_props$styled9 = props.styled) === null || _props$styled9 === void 0 ? void 0 : _props$styled9.disabledBackgroundColor) !== undefined && "background-color: ".concat(props === null || props === void 0 ? void 0 : (_props$styled10 = props.styled) === null || _props$styled10 === void 0 ? void 0 : _props$styled10.disabledBackgroundColor, ";");
});

var Button = function Button(props) {
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(ButtonProto, {
    styled: props,
    disabled: props.disabled,
    onClick: props.onPress,
    type: props.type,
    children: props.children || props.label
  });
};

exports.Button = Button;
Button.displayName = 'Button';
Button.propTypes = _objectSpread(_objectSpread(_objectSpread({}, _templates.baseStyledPropTypes), _templates.textStyledPropTypes), {}, {
  hoverTextDecoration: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  label: _propTypes["default"].string,
  onPress: _propTypes["default"].func
});
Button.defaultProps = _objectSpread(_objectSpread(_objectSpread({}, _templates.baseStyledDefaultProps), _templates.textStyledDefaultProps), {}, {
  height: '44px',
  width: '220px',
  fontSize: _enums.FontSize.Normal,
  fontFamily: _enums.FontFamily.Default,
  fontWeight: _enums.FontWeight.Bold,
  border: 'none',
  alignItems: _enums.AlignItems.Center,
  hoverTextDecoration: null,
  borderRadius: _enums.BorderRadius.Medium,
  color: _enums.Color.White,
  backgroundColor: _enums.Color.BrightTurquoise,
  hoverColor: _enums.Color.White,
  hoverBackgroundColor: _enums.Color.LightBlue,
  disabledColor: _enums.Color.White,
  justifyContent: _enums.JustifyContent.Center,
  disabledBackgroundColor: _enums.Color.MedGrey,
  disabled: false,
  label: ''
});