"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IconButton = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Button = require("./Button");

var _enums = require("../../enums/enums");

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var Icon = _styledComponents["default"].img(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  ", "\n  ", "\n  ", "\n"])), function (props) {
  var _props$styled, _props$styled2;

  return (props === null || props === void 0 ? void 0 : (_props$styled = props.styled) === null || _props$styled === void 0 ? void 0 : _props$styled.height) !== undefined && "height: ".concat(props === null || props === void 0 ? void 0 : (_props$styled2 = props.styled) === null || _props$styled2 === void 0 ? void 0 : _props$styled2.height, ";");
}, function (props) {
  var _props$styled3, _props$styled4;

  return (props === null || props === void 0 ? void 0 : (_props$styled3 = props.styled) === null || _props$styled3 === void 0 ? void 0 : _props$styled3.width) !== undefined && "width: ".concat(props === null || props === void 0 ? void 0 : (_props$styled4 = props.styled) === null || _props$styled4 === void 0 ? void 0 : _props$styled4.width, ";");
}, function (props) {
  var _props$styled5, _props$styled6;

  return (props === null || props === void 0 ? void 0 : (_props$styled5 = props.styled) === null || _props$styled5 === void 0 ? void 0 : _props$styled5.padding) !== undefined && "padding: ".concat(props === null || props === void 0 ? void 0 : (_props$styled6 = props.styled) === null || _props$styled6 === void 0 ? void 0 : _props$styled6.padding, ";");
});

var IconButton = function IconButton(props) {
  var iconStyled = {
    height: props.iconHeight,
    width: props.iconWidth,
    padding: props.iconPadding
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_Button.Button, _objectSpread(_objectSpread({}, props), {}, {
    children: [props.iconSrc !== undefined && /*#__PURE__*/(0, _jsxRuntime.jsx)(Icon, {
      styled: iconStyled,
      alt: props.iconAlt,
      src: props.iconSrc
    }), props.label]
  }));
};

exports.IconButton = IconButton;
IconButton.displayName = 'IconButton';
IconButton.propTypes = _objectSpread(_objectSpread({}, _Button.Button.propTypes), {}, {
  iconAlt: _propTypes["default"].string,
  iconSrc: _propTypes["default"].string,
  iconHeight: _propTypes["default"].string,
  iconWidth: _propTypes["default"].string,
  iconPadding: _propTypes["default"].string
});
IconButton.defaultProps = _objectSpread(_objectSpread({}, _Button.Button.defaultProps), {}, {
  backgroundColor: _enums.Color.Mirage,
  hoverBackgroundColor: _enums.Color.Mirage,
  disabledColor: _enums.Color.White,
  disabledBackgroundColor: _enums.Color.MedGrey,
  iconHeight: '32px',
  iconWidth: '32px',
  iconPadding: '0 20px 0 0',
  iconSrc: undefined
});