"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Dropdown = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _enums = require("../../enums");

var _templates = require("../../templates");

var _jsxRuntime = require("react/jsx-runtime");

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var SelectContainer = _styledComponents["default"].div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  ", ";\n\n  pointer-events: ", ";\n  display: ", ";\n  flex-direction: ", ";\n  position: ", ";\n"])), _templates.baseTemplate, function (props) {
  return props.disabled && _enums.PointerEvents.None || undefined;
}, _enums.Display.Flex, _enums.FlexDirection.Column, _enums.Position.Relative);

var HeaderContainer = _styledComponents["default"].div(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  padding: ", ";\n  display: ", ";\n  align-items: ", ";\n  justify-content: ", ";\n  cursor: pointer;\n  border-bottom: ", ";\n  min-width: ", ";\n  min-height: ", ";\n  box-sizing: ", ";\n  background-color: ", ";\n  border-radius: ", ";\n"])), function (props) {
  return props.padding;
}, _enums.Display.Flex, _enums.AlignItems.Center, _enums.JustifyContent.SpaceBetween, function (props) {
  return props.bottomBorder;
}, function (props) {
  return props.width;
}, function (props) {
  return props.height;
}, _enums.BoxSizing.BorderBox, function (props) {
  return props.backgroundColor;
}, function (props) {
  return props.borderRadius;
});

var Header = _styledComponents["default"].div(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  ", ";\n\n  color: ", ";\n  font-family: ", ";\n  margin: ", ";\n  margin-left: ", ";\n"])), _templates.textTemplate, function (props) {
  return props.color;
}, _enums.FontFamily.Default, _enums.Margin.None, _enums.Margin.XSmall);

var ChevronContainer = _styledComponents["default"].div(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  width: ", ";\n  height: ", ";\n  line-height: ", ";\n  background-color: ", ";\n  padding: ", ";\n  text-align: ", ";\n  color: ", ";\n  font-size: ", ";\n"])), function (props) {
  return props.width;
}, function (props) {
  return props.height;
}, function (props) {
  return props.lineHeight;
}, function (props) {
  return props.backgroundColor;
}, function (props) {
  return props.padding;
}, _enums.TextAlign.Center, function (props) {
  return props.color;
}, function (props) {
  return props.fontSize;
});

var OptionsContainer = _styledComponents["default"].ul(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n  border-radius: ", ";\n  position: ", ";\n  top: ", ";\n  display: ", ";\n  max-height: ", ";\n  max-width: ", ";\n  height: auto;\n  width: 100%;\n  overflow: ", ";\n  visibility: ", ";\n  transform: translateY(", ");\n  flex-direction: ", ";\n  opacity: ", ";\n  padding: 0;\n  transition: opacity ", ", visibility ", ", transform ", ";\n  box-shadow: ", ";\n  background-color: ", ";\n  margin: ", ";\n  box-sizing: ", ";\n  z-index: 100;\n"])), function (props) {
  return props.borderRadius;
}, _enums.Position.Absolute, function (props) {
  return props.top;
}, _enums.Display.Flex, function (props) {
  return props.maxHeight;
}, function (props) {
  return props.maxWidth;
}, _enums.Overflow.Auto, function (props) {
  return props.showContent && _enums.Visibility.Visible || _enums.Visibility.Hidden;
}, function (props) {
  return props.showContent && '0' || '-5px';
}, _enums.FlexDirection.Column, function (props) {
  return props.showContent ? '1' : '0';
}, _enums.TransitionDuration.Standard, _enums.TransitionDuration.Standard, _enums.TransitionDuration.Standard, function (props) {
  return props.boxShadow;
}, function (props) {
  return props.backgroundColor;
}, _enums.Margin.None, _enums.BoxSizing.BorderBox);

var Options = _styledComponents["default"].li(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n  ", ";\n\n  font-family: ", ";\n  color: ", ";\n  background-color: ", ";\n\n  &:hover {\n    color: ", ";\n    background-color: ", ";\n    cursor: pointer;\n  }\n"])), _templates.textTemplate, _enums.FontFamily.Default, function (props) {
  return props.color;
}, function (props) {
  return props.backgroundColor;
}, function (props) {
  return props.hoverColor;
}, function (props) {
  return props.hoverBackgroundColor;
});

var Item = _styledComponents["default"].div(_templateObject7 || (_templateObject7 = _taggedTemplateLiteral(["\n  ", ";\n\n  margin: ", " ", ";\n  padding: 12px 8px 12px 0;\n  border-bottom: ", ";\n"])), _templates.textTemplate, _enums.Margin.None, _enums.Margin.XSmall, function (props) {
  return props.bottomBorder;
});

var Dropdown = function Dropdown(props) {
  var optionsContainerRef = _react["default"].useRef();

  var selectContainerRef = _react["default"].useRef();

  var _React$useState = _react["default"].useState({
    optionsContainerTop: '0px',
    optionsContainerMaxWidth: undefined,
    optionsContainerMaxHeight: undefined,
    defaultHeight: undefined
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      state = _React$useState2[0],
      setState = _React$useState2[1];

  _react["default"].useEffect(function () {
    var _optionsContainerRef$;

    var optionsRect = optionsContainerRef === null || optionsContainerRef === void 0 ? void 0 : (_optionsContainerRef$ = optionsContainerRef.current) === null || _optionsContainerRef$ === void 0 ? void 0 : _optionsContainerRef$.getBoundingClientRect();

    if (!optionsRect || optionsRect.height === state.defaultHeight) {
      return;
    }

    setState(function (prevState) {
      return _objectSpread(_objectSpread({}, prevState), {}, {
        defaultHeight: optionsRect.height
      });
    });
  });

  _react["default"].useEffect(function () {
    var _optionsContainerRef$2, _selectContainerRef$c, _optionsContainerRef$3, _optionsContainerRef$4;

    if (!state.defaultHeight) {
      return;
    }

    var optionsRect = optionsContainerRef === null || optionsContainerRef === void 0 ? void 0 : (_optionsContainerRef$2 = optionsContainerRef.current) === null || _optionsContainerRef$2 === void 0 ? void 0 : _optionsContainerRef$2.getBoundingClientRect();
    var selectRect = selectContainerRef === null || selectContainerRef === void 0 ? void 0 : (_selectContainerRef$c = selectContainerRef.current) === null || _selectContainerRef$c === void 0 ? void 0 : _selectContainerRef$c.getBoundingClientRect();
    var scrollableOptions = (optionsContainerRef === null || optionsContainerRef === void 0 ? void 0 : (_optionsContainerRef$3 = optionsContainerRef.current) === null || _optionsContainerRef$3 === void 0 ? void 0 : _optionsContainerRef$3.scrollHeight) > (optionsContainerRef === null || optionsContainerRef === void 0 ? void 0 : (_optionsContainerRef$4 = optionsContainerRef.current) === null || _optionsContainerRef$4 === void 0 ? void 0 : _optionsContainerRef$4.clientHeight);

    if (!optionsRect || !selectRect) {
      return;
    }

    var containerRect = !!props.containerRect && props.containerRect || {
      width: window.innerWidth,
      height: window.innerHeight
    };

    if (!containerRect.top) {
      containerRect.top = 0;
    }

    setState(function (prevState) {
      return _objectSpread(_objectSpread({}, prevState), {}, {
        optionsContainerMaxWidth: "".concat(containerRect.width - selectRect.left, "px"),
        optionsContainerMaxHeight: "".concat(containerRect.height, "px"),
        optionsContainerTop: (scrollableOptions || selectRect.top + state.defaultHeight > containerRect.height + containerRect.top) && "".concat(containerRect.height - optionsRect.height - selectRect.top + containerRect.top, "px") || '0px'
      });
    });
  }, [state.defaultHeight, props.containerRect]);

  var getOptions = function getOptions() {
    var arr = [];

    var _loop = function _loop(index) {
      var option = props.options[index];
      arr.push( /*#__PURE__*/(0, _jsxRuntime.jsx)(Options, {
        color: props.optionColor,
        borderColor: props.optionBorderColor,
        hoverColor: props.optionHoverColor,
        hoverBackgroundColor: props.optionHoverBackgroundColor,
        backgroundColor: props.optionsBackgroundColor,
        value: option.value,
        onClick: function onClick() {
          return !props.disabled && typeof props.onClick === 'function' && props.onClick(option);
        },
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(Item, {
          bottomBorder: props.itemBottomBorder,
          children: option.display
        })
      }, option.key));
    };

    for (var index = 0; index < props.options.length; index++) {
      _loop(index);
    }

    return arr;
  };

  var renderHeaderContent = function renderHeaderContent() {
    var _props$selected, _props$selected2;

    return ((_props$selected = props.selected) === null || _props$selected === void 0 ? void 0 : _props$selected.displayCollapsed) || ((_props$selected2 = props.selected) === null || _props$selected2 === void 0 ? void 0 : _props$selected2.display) || props.headerText;
  };

  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(SelectContainer, {
    ref: selectContainerRef,
    styled: props,
    disabled: props.disabled,
    width: props.width,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)(HeaderContainer, {
      padding: props.headerContainerPadding,
      onClick: function onClick() {
        return !props.disabled && typeof props.onHeaderPress === 'function' && props.onHeaderPress();
      },
      showContent: props.showContent,
      width: props.headerWidth,
      height: props.headerHeight,
      backgroundColor: props.headerBackgroundColor,
      bottomBorder: props.headerBottomBorder,
      borderRadius: props.headerBorderRadius,
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(Header, {
        styled: props,
        color: props.headerTextColor,
        children: renderHeaderContent()
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(ChevronContainer, {
        color: props.chevronColor,
        backgroundColor: props.chevronBackgroundColor,
        padding: props.chevronPadding,
        fontSize: props.chevronFontSize,
        width: props.chevronWidth,
        height: props.chevronHeight,
        children: !props.disabled && props.showContent && props.chevronUp || props.chevronDown
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(OptionsContainer, {
      top: state.optionsContainerTop,
      ref: optionsContainerRef,
      type: 'none',
      maxHeight: state.optionsContainerMaxHeight,
      maxWidth: state.optionsContainerMaxWidth,
      padding: props.optionsContainerPadding,
      showContent: !props.disabled && props.showContent,
      backgroundColor: props.optionsContainerBackgroundColor,
      boxShadow: props.optionsBoxShadow,
      borderRadius: props.optionsContainerBorderRadius,
      children: getOptions()
    })]
  });
};

exports.Dropdown = Dropdown;
Dropdown.displayName = 'Dropdown';
Dropdown.propTypes = _objectSpread(_objectSpread(_objectSpread({}, _templates.baseStyledPropTypes), _templates.textStyledPropTypes), {}, {
  chevronBackgroundColor: _propTypes["default"].oneOf(Object.values(_enums.Color)),
  chevronColor: _propTypes["default"].oneOf(Object.values(_enums.Color)),
  chevronDown: _propTypes["default"].string.isRequired,
  chevronFontSize: _propTypes["default"].string.isRequired,
  chevronPadding: _propTypes["default"].string,
  chevronUp: _propTypes["default"].string.isRequired,
  disabled: _propTypes["default"].bool,
  headerBackgroundColor: _propTypes["default"].oneOf(Object.values(_enums.Color)),
  headerBorderRadius: _propTypes["default"].string,
  headerBottomBorder: _propTypes["default"].string.isRequired,
  headerContainerPadding: _propTypes["default"].string.isRequired,
  headerHeight: _propTypes["default"].string.isRequired,
  headerText: _propTypes["default"].string.isRequired,
  headerTextColor: _propTypes["default"].oneOf(Object.values(_enums.Color)),
  headerWidth: _propTypes["default"].string.isRequired,
  itemBottomBorder: _propTypes["default"].string,
  onHeaderPress: _propTypes["default"].func,
  optionBorderColor: _propTypes["default"].oneOf(Object.values(_enums.Color)),
  optionColor: _propTypes["default"].oneOf(Object.values(_enums.Color)),
  optionHoverBackgroundColor: _propTypes["default"].oneOf(Object.values(_enums.Color)),
  optionHoverColor: _propTypes["default"].oneOf(Object.values(_enums.Color)),
  options: _propTypes["default"].array.isRequired,
  optionsBackgroundColor: _propTypes["default"].oneOf(Object.values(_enums.Color)),
  optionsBoxShadow: _propTypes["default"].string,
  optionsContainerBackgroundColor: _propTypes["default"].oneOf(Object.values(_enums.Color)),
  optionsContainerBorderRadius: _propTypes["default"].string,
  optionsContainerPadding: _propTypes["default"].string,
  selected: _propTypes["default"].shape({
    displayCollapsed: _propTypes["default"].node,
    display: _propTypes["default"].node
  }),
  showContent: _propTypes["default"].bool.isRequired,
  containerRect: _propTypes["default"].shape({
    width: _propTypes["default"].number,
    height: _propTypes["default"].number
  })
});
Dropdown.defaultProps = _objectSpread(_objectSpread(_objectSpread({}, _templates.baseStyledDefaultProps), _templates.textStyledDefaultProps), {}, {
  width: '200px',
  chevronBackgroundColor: _enums.Color.Transparent,
  chevronColor: _enums.Color.BrightTurquoise,
  chevronDown: "\u25BC",
  chevronFontSize: _enums.FontSize.Smallest,
  chevronPadding: '0px',
  chevronUp: "\u25B2",
  disabled: false,
  headerBackgroundColor: _enums.Color.White,
  headerBorderRadius: '0',
  headerBottomBorder: "2px ".concat(_enums.BorderStyle.Solid, " ").concat(_enums.Color.MedGrey),
  headerContainerPadding: '8px 8px 8px 0',
  headerHeight: '30px',
  headerText: 'Select',
  headerTextColor: _enums.Color.MedGrey,
  headerWidth: '20px',
  itemBottomBorder: "1px ".concat(_enums.BorderStyle.Solid, " ").concat(_enums.Color.MedGrey),
  onHeaderPress: undefined,
  optionBorderColor: _enums.Color.MedGrey,
  optionColor: _enums.Color.Black,
  optionHoverBackgroundColor: _enums.Color.BrightTurquoise,
  optionHoverColor: _enums.Color.White,
  options: [],
  optionsBackgroundColor: _enums.Color.White,
  optionsBoxShadow: "1px 1px 8px 3px ".concat(_enums.Color.MedGrey),
  optionsContainerBackgroundColor: _enums.Color.White,
  optionsContainerBorderRadius: '0',
  optionsContainerPadding: '8px 15px',
  selected: null,
  showContent: false
});