"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WordBreak = exports.WhiteSpace = exports.Visibility = exports.VerticalAlign = exports.UserSelect = exports.TransitionDuration = exports.TextTransform = exports.TextOverflow = exports.TextDecorationLine = exports.TextAlign = exports.ResizeMode = exports.Position = exports.PointerEvents = exports.Overflow = exports.Orientation = exports.ObjectFit = exports.Margin = exports.LayoutDirection = exports.JustifyContent = exports.InputTypes = exports.Hyphens = exports.FormFactor = exports.FontWeight = exports.FontStyle = exports.FontSize = exports.FontFamily = exports.FlexWrap = exports.FlexDirection = exports.FillRule = exports.Display = exports.Direction = exports.Color = exports.BoxSizing = exports.BorderStyle = exports.BorderRadius = exports.AnimationTimingFunction = exports.AlignSelf = exports.AlignItems = exports.AlignContent = void 0;
var FormFactor = {
  Feature: 0,
  Mobile: 1,
  Tablet: 2,
  Desktop: 3
};
exports.FormFactor = FormFactor;
var Orientation = {
  Portrait: 'portrait',
  Landscape: 'landscape'
};
exports.Orientation = Orientation;
var LayoutDirection = {
  Horizontal: 'horizontal',
  Vertical: 'vertical'
};
exports.LayoutDirection = LayoutDirection;
var Color = {
  CurrentColor: 'currentColor',
  Transparent: '#00000000',
  TransparentBlack: '#00000080',
  TransparentWhite: '#FFFFFF80',
  TransparentDarkGrey: '#33333380',
  TransparentGrey: '#66666660',
  TransparentBlue: '#007CCAA0',
  TransparentLightGrey: '#BCBDC01A',
  TransparentLightBlue: '#007CCA20',
  TransparentLightGreen: '#A8B40020',
  TransparentOrange: '#FF4C0060',
  Black: '#000000',
  White: '#FFFFFF',
  Slate: '#2A3C4C',
  LightSlate: '#546470',
  LighterSlate: '#949EA6',
  LightestSlate: '#EAECED',
  MedGrey: '#AEAEAE',
  LightGrey: '#EFEFEF',
  LightestGrey: '#F8F8F8',
  Granite: '#242424',
  Charcoal: '#4D4D4D',
  Smoke: '#959595',
  CraterDust: '#EDEDED',
  BlueMist: '#83919F',
  Negative: '#DE292E',
  VeryDarkGrey: '#282828',
  DarkGrey: '#333333',
  BrightBlue: '#00B5EF',
  Turquoise: '#2BE2CB',
  BrightTurquoise: '#1AC2F5',
  AllPortsBlue: '#1E7097',
  CyprusBlue: '#103d54',
  Mirage: '#15212D',
  GableGreen: '#1B2B3A',
  RegentGrey: '#85929f',
  Bunker: '#101920',
  YellowGradient: 'linear-gradient(65.31deg, #BB6500 27.17%, #F5E42C 91.6%)',
  BlueGradient: 'linear-gradient(246.83deg, #00C3FF 3.33%, #1C2B3A 81.86%)',
  GreenGradient: 'linear-gradient(247.18deg, #81D138 8.9%, #275A1F 62.6%)',
  PurpleGradient: 'linear-gradient(246.79deg, #DA0079 7.87%, #46244E 87.08%)',
  Grey: '#5A646F',
  Red: '#FF000F',
  DarkRed: '#880000',
  Green: '#00EE00',
  LightGreen: '#A8B400',
  Yellow: '#EBE61C',
  Mustard: '#F2A900',
  Teal: '#598497',
  Blue: '#007CCA',
  Orange: '#F05A1E',
  GreyPink: '#e7dbe8',
  LightPink: '#c8a5ca',
  MidPink: '#af7ab2',
  DarkPurple: '#91288C'
};
exports.Color = Color;
var FontSize = {
  Tiny: '9px',
  Smallest: '11px',
  Smaller: '12px',
  Small: '14px',
  Normal: '16px',
  Big: '18px',
  Bigger: '20px',
  Biggest: '22px',
  Huge: '28px'
};
exports.FontSize = FontSize;
var FontFamily = {
  Default: '"BentonSans", "Roboto", "Helvetica", sans-serif',
  BentonSans: 'BentonSans',
  Serif: 'serif',
  SansSerif: 'sans-serif',
  Monospace: 'Monospace',
  TimesNewRoman: 'Times New roman',
  Roboto: 'Roboto'
};
exports.FontFamily = FontFamily;
var FontWeight = {
  Normal: 'normal',
  Bold: 'bold',
  100: '100',
  200: '200',
  300: '300',
  400: '400',
  500: '500',
  600: '600',
  700: '700',
  800: '800',
  900: '900'
};
exports.FontWeight = FontWeight;
var FontStyle = {
  Normal: 'normal',
  Italic: 'italic'
};
exports.FontStyle = FontStyle;
var TextAlign = {
  Auto: 'auto',
  Left: 'left',
  Right: 'right',
  Center: 'center',
  Justify: 'justify'
};
exports.TextAlign = TextAlign;
var TextDecorationLine = {
  None: 'none',
  Underline: 'underline',
  LineThrough: 'line-through',
  UnderlineLineThrough: 'underline line-through'
};
exports.TextDecorationLine = TextDecorationLine;
var TextTransform = {
  None: 'none',
  Uppercase: 'uppercase',
  Lowercase: 'lowercase',
  Capitalize: 'capitalize'
};
exports.TextTransform = TextTransform;
var PointerEvents = {
  Auto: 'auto',
  None: 'none',
  BoxNone: 'box-none',
  BoxOnly: 'box-only'
};
exports.PointerEvents = PointerEvents;
var Visibility = {
  Visible: 'visible',
  Hidden: 'hidden'
};
exports.Visibility = Visibility;
var BorderStyle = {
  Solid: 'solid',
  Dotted: 'dotted',
  Dashed: 'dashed',
  None: 'none'
};
exports.BorderStyle = BorderStyle;
var AlignContent = {
  Start: 'flex-start',
  End: 'flex-end',
  Center: 'center',
  Stretch: 'stretch',
  SpaceBetween: 'space-between',
  SpaceAround: 'space-around'
};
exports.AlignContent = AlignContent;
var AlignItems = {
  Start: 'flex-start',
  End: 'flex-end',
  Center: 'center',
  Stretch: 'stretch',
  Baseline: 'baseline'
};
exports.AlignItems = AlignItems;
var AlignSelf = {
  Auto: 'auto',
  Start: 'flex-start',
  End: 'flex-end',
  Center: 'center',
  Stretch: 'stretch',
  Baseline: 'baseline'
};
exports.AlignSelf = AlignSelf;
var Direction = {
  Auto: 'auto',
  LeftToRight: 'ltr',
  RightToLeft: 'rtl'
};
exports.Direction = Direction;
var Display = {
  None: 'none',
  Flex: 'flex'
};
exports.Display = Display;
var BoxSizing = {
  ContentBox: 'content-box',
  BorderBox: 'border-box'
};
exports.BoxSizing = BoxSizing;
var FlexDirection = {
  Row: 'row',
  RowReverse: 'row-reverse',
  Column: 'column',
  ColumnReverse: 'column-reverse'
};
exports.FlexDirection = FlexDirection;
var FlexWrap = {
  Wrap: 'wrap',
  NoWrap: 'nowrap',
  WrapReverse: 'wrap-reverse'
};
exports.FlexWrap = FlexWrap;
var JustifyContent = {
  Start: 'flex-start',
  End: 'flex-end',
  Center: 'center',
  SpaceBetween: 'space-between',
  SpaceAround: 'space-around',
  SpaceEvenly: 'space-evenly'
};
exports.JustifyContent = JustifyContent;
var Overflow = {
  Visible: 'visible',
  Hidden: 'hidden',
  Scroll: 'scroll',
  Auto: 'auto'
};
exports.Overflow = Overflow;
var Position = {
  Absolute: 'absolute',
  Relative: 'relative'
};
exports.Position = Position;
var ResizeMode = {
  Cover: 'cover',
  Contain: 'contain',
  Stretch: 'stretch',
  Repeat: 'repeat',
  Center: 'center'
};
exports.ResizeMode = ResizeMode;
var UserSelect = {
  None: 'none',
  Auto: 'auto'
};
exports.UserSelect = UserSelect;
var WordBreak = {
  Normal: 'normal',
  BreakAll: 'break-all',
  KeepAll: 'keep-all'
};
exports.WordBreak = WordBreak;
var VerticalAlign = {
  Baseline: 'baseline',
  Sub: 'sub',
  Super: 'super',
  TextTop: 'text-top',
  TextBottom: 'text-bottom',
  Middle: 'middle',
  Top: 'top',
  Bottom: 'bottom'
};
exports.VerticalAlign = VerticalAlign;
var WhiteSpace = {
  Normal: 'normal',
  Nowrap: 'nowrap',
  Pre: 'pre',
  PreWrap: 'pre-wrap',
  PreLine: 'pre-line',
  BreakSpaces: 'break-spaces'
};
exports.WhiteSpace = WhiteSpace;
var TextOverflow = {
  Clip: 'clip',
  Ellipsis: 'ellipsis'
};
exports.TextOverflow = TextOverflow;
var Hyphens = {
  None: 'none',
  Manual: 'manual',
  Auto: 'auto'
};
exports.Hyphens = Hyphens;
var InputTypes = {
  Text: 'text',
  Date: 'date',
  Number: 'number',
  Url: 'url',
  Email: 'email',
  PhoneNumber: 'tel',
  Password: 'password',
  Search: 'search',
  Color: 'color'
};
exports.InputTypes = InputTypes;
var ObjectFit = {
  Contain: 'contain',
  Cover: 'cover',
  Fill: 'fill',
  None: 'none',
  ScaleDown: 'scale-down'
};
exports.ObjectFit = ObjectFit;
var FillRule = {
  NonZero: 'nonzero',
  EvenOdd: 'evenodd'
};
exports.FillRule = FillRule;
var BorderRadius = {
  Medium: '8px',
  StandardMenuItem: '10px',
  StandardCard: '13px',
  Ellipse: '50%'
};
exports.BorderRadius = BorderRadius;
var Margin = {
  None: '0px',
  XSmall: '5px',
  Small: '10px',
  Medium: '15px',
  Large: '25px',
  XLarge: '35px'
};
exports.Margin = Margin;
var TransitionDuration = {
  Standard: '0.3s',
  Long: '1.5s'
};
exports.TransitionDuration = TransitionDuration;
var AnimationTimingFunction = {
  Linear: 'linear',
  Ease: 'ease',
  EaseIn: 'ease-in',
  EaseOut: 'ease-out',
  EaseInOut: 'ease-in-out'
};
exports.AnimationTimingFunction = AnimationTimingFunction;